'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.extendMethod = extendMethod;
exports.extendProperty = extendProperty;

var _hasOwn = require('has-own');

var _hasOwn2 = _interopRequireDefault(_hasOwn);

var _Image = require('../Image');

var _Image2 = _interopRequireDefault(_Image);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var computedPropertyDescriptor = {
  configurable: true,
  enumerable: false,
  get: undefined
};

function extendMethod(name, method, options = {}) {
  var _options$inPlace = options.inPlace,
      inPlace = _options$inPlace === undefined ? false : _options$inPlace,
      _options$returnThis = options.returnThis,
      returnThis = _options$returnThis === undefined ? true : _options$returnThis,
      _options$partialArgs = options.partialArgs,
      partialArgs = _options$partialArgs === undefined ? [] : _options$partialArgs;


  if (inPlace) {
    _Image2.default.prototype[name] = function (...args) {
      // remove computed properties
      this.computed = null;
      var result = method.apply(this, [...partialArgs, ...args]);
      if (returnThis) {
        return this;
      }
      return result;
    };
  } else {
    _Image2.default.prototype[name] = function (...args) {
      return method.apply(this, [...partialArgs, ...args]);
    };
  }
  return _Image2.default;
}

function extendProperty(name, method, options = {}) {
  var _options$partialArgs2 = options.partialArgs,
      partialArgs = _options$partialArgs2 === undefined ? [] : _options$partialArgs2;


  computedPropertyDescriptor.get = function () {
    if (this.computed === null) {
      this.computed = {};
    } else if ((0, _hasOwn2.default)(name, this.computed)) {
      return this.computed[name];
    }
    var result = method.apply(this, partialArgs);
    this.computed[name] = result;
    return result;
  };
  Object.defineProperty(_Image2.default.prototype, name, computedPropertyDescriptor);
  return _Image2.default;
}