'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getSeparatedKernel;

var _mlMatrix = require('ml-matrix');

function getSeparatedKernel(kernel) {
  var svd = new _mlMatrix.SVD(kernel, { autoTranspose: true });
  if (svd.rank !== 1) return null;
  var s = Math.sqrt(svd.s[0]);
  var v = svd.U.map(v => v[0] * s);
  var h = svd.V.map(h => h[0] * s);
  return [v, h];
}